<template>
    <v-container fluid>
        <ValidationObserver ref="observer" slim>
            <v-row>
                <v-col class="d-flex justify-end py-0">
                    <v-switch
                        dense
                        hide-details
                        class="mt-0"
                        v-model="enabled"
                        :loading="loading"
                        :label="$t('enabled')"
                        :true-value="true"
                        :false-value="false"
                    ></v-switch>
                </v-col>
                <v-col cols="12">
                    <div class="field-label">{{ $t('type') }}</div>
                    <ValidationProvider name="type" rules="required" v-slot="{ errors }">
                        <v-select
                            dense
                            outlined
                            v-model="type"
                            :loading="loading"
                            :items="types"
                            :error-messages="errors"
                            hide-details="auto"
                            item-text="name"
                            item-value="id"
                            :menu-props="{ bottom: true, offsetY: true }"
                        >
                            <template slot="selection" slot-scope="data">
                                {{ $t(data.item.name) }}
                            </template>
                            <template slot="item" slot-scope="data">
                                {{ $t(data.item.name) }}
                            </template>
                        </v-select>
                    </ValidationProvider>
                </v-col>
                <v-col>
                    <div class="field-label">{{ $t('start_time') }}</div>
                    <validation-provider vid="start_time" v-slot="{ errors }" name="start_time" rules="required">
                        <v-menu
                            ref="startTimePicker"
                            :close-on-content-click="false"
                            :nudge-right="40"
                            :return-value.sync="startTime"
                            transition="scale-transition"
                            offset-y
                            max-width="290px"
                        >
                            <template v-slot:activator="{ on, attrs }">
                                <v-text-field
                                    v-model="startTime"
                                    :loading="loading"
                                    :error-messages="errors"
                                    prepend-inner-icon="mdi-clock-time-four-outline"
                                    hide-details="auto"
                                    v-bind="attrs"
                                    v-on="on"
                                    readonly
                                    dense
                                    outlined
                                ></v-text-field>
                            </template>
                            <v-time-picker
                                v-model="startTime"
                                @click:minute="$refs.startTimePicker.save(startTime)"
                                full-width
                                format="ampm"
                                ampm-in-title
                            ></v-time-picker>
                        </v-menu>
                    </validation-provider>
                </v-col>
                <v-col>
                    <div class="field-label">{{ $t('end_time') }}</div>
                    <validation-provider vid="end_time" name="end_time" rules="required" v-slot="{ errors }">
                        <v-menu
                            ref="endTimePicker"
                            :close-on-content-click="false"
                            :nudge-right="40"
                            :return-value.sync="endTime"
                            transition="scale-transition"
                            offset-y
                            max-width="290px"
                        >
                            <template v-slot:activator="{ on, attrs }">
                                <v-text-field
                                    v-model="endTime"
                                    :loading="loading"
                                    :error-messages="errors"
                                    prepend-inner-icon="mdi-clock-time-four-outline"
                                    hide-details="auto"
                                    v-bind="attrs"
                                    v-on="on"
                                    readonly
                                    dense
                                    outlined
                                ></v-text-field>
                            </template>
                            <v-time-picker
                                v-model="endTime"
                                @click:minute="$refs.endTimePicker.save(endTime)"
                                full-width
                                format="ampm"
                                ampm-in-title
                            ></v-time-picker>
                        </v-menu>
                    </validation-provider>
                </v-col>
                <v-col cols="12">
                    <div class="field-label">{{ $t('limit') }}</div>
                    <ValidationProvider name="limit" rules="required|min_value:1" v-slot="{ errors }">
                        <v-text-field
                            dense
                            outlined
                            type="number"
                            hide-details="auto"
                            v-model="limit"
                            :loading="loading"
                            :error-messages="errors"
                        ></v-text-field>
                    </ValidationProvider>
                </v-col>
                <v-col class="text-center">
                    <v-btn
                        color="primary"
                        @click="onClick"
                        :loading="loading"
                    >
                        {{ isEditMode ? $t('save') : $t('create') }}
                    </v-btn>
                </v-col>
            </v-row>
        </ValidationObserver>
    </v-container>
</template>

<script>
    import moment from "moment";
    import { ValidationObserver, ValidationProvider } from "vee-validate";

    export default {
        name: "TimeslotForm",
        components: {
            ValidationObserver,
            ValidationProvider
        },
        props: {
            loading: {
                type: Boolean,
                default: false
            },
            types: {
                type: Array,
                default: () => []
            },
            errors: {
                type: [Array, Object],
                default: () => []
            },
            mode: {
                type: String,
                default: 'create',
                validator: value => ['create', 'edit'].indexOf(value) !== -1
            },
            timeslot: {
                type: Object,
                default: () => ({})
            }
        },
        data: () => ({
            type: null,
            startTime: null,
            endTime: null,
            limit: 0,
            enabled: true
        }),
        created() {
            if(this.isEditMode) {
                this.type = this.timeslot.type_id
                this.startTime = this.timeslot.start_time
                this.endTime = this.timeslot.end_time
                this.limit = this.timeslot.limit
                this.enabled = this.timeslot.enabled
            }
        },
        computed: {
            isEditMode() {
                return this.mode === 'edit'
            }
        },
        watch: {
            errors(val) {
                if(val) {
                    this.$refs.observer.setErrors(val)
                }
            }
        },
        methods: {
            utcTime(time) {
                return moment(time, 'H:i').utc().format('HH:mm')
            },
            async onClick() {
                const valid = await this.$refs.observer.validate()

                if(valid) {
                    this.$emit('validated', {
                        type_id: this.type,
                        start_time: this.utcTime(this.startTime),
                        end_time: this.utcTime(this.endTime),
                        limit: this.limit,
                        enabled: this.enabled
                    })
                }
            }
        }
    }
</script>

<style scoped>
    .justify-type >>> .v-input--radio-group__input {
        justify-content: center;
    }
</style>
